﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;
using HeuristicLab.Data;
using HeuristicLab.Parameters;

namespace HeuristicLab.SimulationCore.Samples {
  [Item("SimpleScenario", "A simple scenario.")]
  [StorableClass]
  public sealed class SimpleScenario: Scenario {
    public ValueParameter<IntValue> InitialValueParameter {
      get { return (ValueParameter<IntValue>)Parameters["InitialValue"]; }
    }
    
    public SimpleScenario() : base() {
      Parameters.Add(new ValueParameter<IntValue>("InitialValue", "The initial counter value.", new IntValue(10)));
    }
    [StorableConstructor]
    private SimpleScenario(bool deserializing) : base(deserializing) { }
    private SimpleScenario(SimpleScenario original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new SimpleScenario(this, cloner);
    }
  }
}
